Ext.define('inubitwebapp.Support', {singleton:true, getBpcIconCls:function(fontAwesomeName) {
  return BpcCommon.util.Icons.getBpcIconCls(fontAwesomeName);
}, getTranslation:function(key) {
  var starter = 'INUBITWEBAPP_';
  key = !Ext.String.startsWith(key, starter) ? starter + key : key;
  return BpcCommon.Api.getTranslation(key);
}, TR:function(k) {
  return this.getTranslation(k);
}, getBaseUrl:function() {
  return 'cxf/bpc-inubitwebapp/';
}, showNotification:function(text) {
  BpcCommon.Api.showNotification(text);
}, confirmDialog:function(title, message) {
  return new Promise(function(resolve) {
    Ext.Msg.show({title:title, message:message, buttons:Ext.Msg.OKCANCEL, icon:Ext.Msg.QUESTION, fn:function(btn) {
      if (btn === 'ok') {
        resolve(true);
      } else if (btn === 'cancel') {
        resolve(false);
      } else {
        resolve(false);
      }
    }});
  });
}, submitViaExtJs:function(method, url, data, headers, moduleId) {
  method = method === void 0 ? 'POST' : method;
  headers = headers === void 0 ? {} : headers;
  var proxyId = BpcCommon.Api.getSetting(moduleId, 'proxyId');
  var $jscomp$destructuring$var0 = BpcCommon.Api.getConnection(proxyId);
  var timeout = $jscomp$destructuring$var0.timeout;
  timeout = timeout || 180000;
  if (!Ext.isObject(headers)) {
    headers = {};
  }
  headers.ConfiguredTimeout = timeout;
  if (Object.hasOwn(headers, 'Content-Type')) {
    if (headers['Content-Type'] === 'application/json') {
      try {
        data = data ? JSON.stringify(data) : {};
      } catch (e) {
        data = {};
      }
    }
  } else {
    headers['Content-Type'] = 'multipart/form-data';
  }
  return Ext.Ajax.request({method:method, url:url, headers:headers, timeout:timeout, rawData:data});
}, copyToClipBoard:function(text, extCmp) {
  function copyToClp(stringWithNewLines) {
    try {
      var myFluffyTextarea = document.createElement('textarea');
      myFluffyTextarea.innerHTML = stringWithNewLines;
      var parentElement = document.getElementById(extCmp.getId());
      parentElement.appendChild(myFluffyTextarea);
      myFluffyTextarea.select();
      document.execCommand('copy');
      parentElement.removeChild(myFluffyTextarea);
      return true;
    } catch (e) {
      return false;
    }
  }
  return copyToClp(text);
}});
Ext.define('inubitwebapp.bpc.webapp.JumpUtil', {alias:['inubitwebapp.inubitwebappJumpFn'], statics:{jumpParamFn:function(record, column, value) {
  return {reInit:true, record:record.getData()};
}}});
Ext.define('inubitwebapp.mixins.Component', {getSetting:function(key, defaultValue) {
  var v = this.doGetSetting(this.moduleId, key);
  return typeof v !== 'undefined' ? v : defaultValue;
}, doGetSetting:function(id, key) {
  return BpcCommon.Api.getSetting(id, key);
}, TR:function(key) {
  return inubitwebapp.Support.TR(key);
}, faIcon:function(icon) {
  return inubitwebapp.Support.getBpcIconCls(icon);
}, showNotification:function(text, type) {
  type = type === void 0 ? 'i' : type;
  var showInfo = this.getSetting('showDefaultNotifications');
  var showError = this.getSetting('showErrorNotifications');
  if (type === 'i' && showInfo) {
    inubitwebapp.Support.showNotification(text);
  }
  if (type === 'e' && showError) {
    inubitwebapp.Support.showNotification(text);
  }
}, showDialog:function(titleKey, msgKey) {
  return inubitwebapp.Support.confirmDialog(this.TR(titleKey), this.TR(msgKey));
}});
Ext.define('inubitwebapp.bpc.webapp.WebAppMain', {extend:'Ext.panel.Panel', alias:'widget.bpcWebAppMain', mixins:['inubitwebapp.mixins.Component'], itemId:'bpcWebAppMain', border:true, padding:10, layout:'fit', bpcContext:'moduleInstance', initComponent:function() {
  var $jscomp$this = this;
  this.header = this.getSetting('view_reinit') || this.getSetting('view_reload');
  if (this.bpcContext === 'plugin') {
    this.title = this.getSetting('module_name');
  }
  this.tools = [{iconCls:this.faIcon('fa-retweet'), width:30, tooltip:this.TR('REINIT_HEADER'), hidden:this.getSetting('view_reinit') === false, handler:function() {
    return $jscomp$this.doReInit();
  }}, {iconCls:this.faIcon('fa-sync'), width:25, tooltip:this.TR('RELOAD_HEADER'), hidden:this.getSetting('view_reload') === false, handler:function() {
    return $jscomp$this.doReload();
  }}];
  this.webAppPage = Ext.create({xtype:'bpcWebAppPage', moduleId:this.moduleId, itemId:'bpcWebAppPage' + this.moduleId, moduleInstance:this.moduleInstance});
  this.items = [this.webAppPage];
  this.callParent(arguments);
}, doReInit:function() {
  var $jscomp$this = this;
  this.showDialog('REINIT_HEADER', 'REINIT_MSG').then(function(yes) {
    if (yes) {
      var jsConn = $jscomp$this.getSetting('Is_JSConnector');
      var url = $jscomp$this.webAppPage.link + '\x26reinit\x3dtrue';
      if (jsConn) {
        if ($jscomp$this.webAppPage.down('#jsConBox')) {
          $jscomp$this.webAppPage.down('#jsConBox').getEl().dom.contentWindow.location = url;
        }
      } else {
        inubitwebapp.services.Script.cleanForReinit($jscomp$this.webAppPage);
        $jscomp$this.webAppPage.loadPage(url);
      }
    }
  });
}, doReload:function() {
  var $jscomp$this = this;
  this.showDialog('RELOAD_HEADER', 'RELOAD_MSG').then(function(yes) {
    if (yes) {
      var jsConn = $jscomp$this.getSetting('Is_JSConnector');
      var url = $jscomp$this.webAppPage.link + ($jscomp$this.webAppPage.errorInPage ? '\x26reinit\x3dtrue' : '');
      if (jsConn) {
        if ($jscomp$this.webAppPage.down('#jsConBox')) {
          $jscomp$this.webAppPage.down('#jsConBox').getEl().dom.contentWindow.location = url;
        }
      } else {
        inubitwebapp.services.Script.cleanForReinit($jscomp$this.webAppPage);
        $jscomp$this.webAppPage.loadPage(url);
      }
      $jscomp$this.webAppPage.errorInPage = false;
    }
  });
}});
Ext.define('inubitwebapp.bpc.webapp.WebAppPage', {extend:'Ext.panel.Panel', alias:'widget.bpcWebAppPage', mixins:['inubitwebapp.mixins.Component'], itemId:'', header:false, border:true, padding:10, autoScroll:true, moduleId:undefined, namespace:undefined, errorInPage:false, activateHelp:'', moduleReinitOnLoad:false, scriptErrorOccurred:false, initComponent:function() {
  var jsConn = this.getSetting('Is_JSConnector');
  this.namespace = 'i_' + this.moduleId.replaceAll('-', '___') + '_';
  this.destroyOldComponents(this.namespace);
  this.lang = BpcCommon.Api.getSetting('_core', 'language');
  this.dataIS = {};
  this.ajaxValidation = {DOM:null, caller:null, submitter:null, errorNodesMustBeVisible:false, currentSelectedNode:null, currentSelectedErrorMessage:null, currentSelectedTimestamp:0, currentMouseposX:0, currentMouseposY:0, portletNS:'', form:null, allErrorNodesAreBlocked:false};
  this.activateHelp = this.getSetting('activate_help');
  this.moduleReinitOnLoad = this.getSetting('module_reinit_onload');
  this.link = inubitwebapp.Support.getBaseUrl();
  if (jsConn) {
    this.link = this.link + 'jsConnector/';
  }
  this.link = this.link + this.moduleId + '/' + BpcCommon.Api.getSetting(this.moduleId, 'web_application_id') + '?activateHelp\x3d' + this.activateHelp + '\x26lang\x3d' + this.lang;
  if (jsConn) {
    this.link = this.link + '\x26portletContext\x3d' + this.getSetting('JSConnector_Context') + '\x26divId\x3d' + this.getSetting('JSConnector_Div_Id') + '\x26is_jsconnector\x3d' + jsConn + '\x26jsObjectName\x3d' + this.getSetting('JSConnector_Object_Name') + '\x26bpcComponentId\x3d' + this.id + '\x26moduleCfg\x3d{';
    var defParams = Ext.urlEncode(this.getAppConfig()).replaceAll('\x26', ',');
    this.link = this.link + defParams + '}';
    this.items = [{xtype:'box', itemId:'jsConBox', width:'100%', height:'100%', autoEl:{tag:'iframe', src:this.link}}];
  } else {
    this.form = this.formName;
    this.title = this.taskName;
    var url = this.link;
    if (this.moduleInstance && this.moduleInstance.moduleCfg && this.moduleInstance.moduleCfg.reInit && this.moduleInstance.moduleCfg.reInit === true || this.getSetting('module_reinit_onload') === true) {
      url += '\x26reinit\x3dtrue';
    }
    this.loadPage(url);
  }
  this.callParent(arguments);
}, getAppConfig:function() {
  return this.moduleInstance && this.moduleInstance.moduleCfg && !Ext.Object.isEmpty(this.moduleInstance.moduleCfg) ? this.moduleInstance.moduleCfg : this.getSetting('default_params');
}, loadPage:function(link, config) {
  var $jscomp$this = this;
  link = link || this.link;
  config = config || this.getAppConfig();
  link = link + '\x26bpcComponentId\x3d' + this.id;
  this.setLoading('LOADING_WEBAPP');
  inubitwebapp.Support.submitViaExtJs('POST', link, config, {'Content-Type':'application/json'}, this.moduleId).then(function(response) {
    if (response.status === 200 && response.responseText) {
      $jscomp$this.setHtml(response.responseText);
      inubitwebapp.services.Script.loadAJAXScriptsIS(response, $jscomp$this, $jscomp$this.namespace);
    }
    $jscomp$this.setLoading(false);
  }, function(error) {
    $jscomp$this.setLoading(false);
    $jscomp$this.handleError(error);
  });
}, setLoading:function(StrOrFalse) {
  StrOrFalse = StrOrFalse === void 0 ? 'LOADING_DATA' : StrOrFalse;
  var setLoadingParam = StrOrFalse === false ? false : this.TR(StrOrFalse);
  this.callParent([setLoadingParam]);
}, handleError:function(error) {
  if (error.status === 503) {
    error.statusText = this.TR('SERVICE_UNAVAILABLE_MSG');
    this.showNotification(this.TR('SERVICE_UNAVAILABLE_MSG'), 'e');
  } else if (error.status === 401) {
    error.statusText = this.TR('UNAUTHORIZED');
    this.showNotification(this.TR('UNAUTHORIZED'), 'e');
  } else if (error.status === 417) {
    error.statusText = this.TR('EXPECTATION_FAILED');
    this.showNotification(this.TR('EXPECTATION_FAILED'), 'e');
  } else if (error.status === 400) {
    if (error.getResponseHeader('Process_Id')) {
      error.statusText = BpcCommon.Api.getTranslation({key:'INUBITWEBAPP_BAD_REQUEST_MSG', data:{processId:error.getResponseHeader('Process_Id')}});
    } else {
      error.statusText = this.TR('BACKEND_ERROR');
    }
  }
  this.destroyOldComponents(this.namespace);
  this.setHtml('');
  this.errorInPage = true;
  this.add({xtype:'panel', margin:'10 10 10 10', html:'\x3cdiv\x3e\x3ch1\x3e' + this.TR('SERVER_ERROR') + '\x3c/h1\x3e' + '\x3ch3\x3e' + error.statusText + '\x3c/h3\x3e\x3c/div\x3e'});
}, destroyOldComponents:function(namespace) {
  var panels = Ext.ComponentQuery.query('panel[id\x3d"' + namespace + 'MainPanel"]');
  if (panels && panels.length > 0) {
    Ext.each(panels, function(panel) {
      panel.destroy();
    });
  }
  if (this.items && this.down('#forceJSerrorPanel')) {
    this.remove(this.down('#forceJSerrorPanel'));
  }
  this.scriptErrorOccurred = false;
}, setDataIS:function(dataIS) {
  this.dataIS = dataIS;
}, updateDataISArray:function(variable, value) {
  if (!this.dataIS[variable]) {
    this.dataIS[variable] = [];
  }
  this.dataIS[variable].push(value);
}, updateDataISProp:function(property, value) {
  this.dataIS[property] = value;
}, initIS:function(ns) {
  try {
    if (this.dataIS['ajaxLoad']) {
      try {
        if (this.ajaxValidation.form !== null) {
          this.ajaxValidation.form.style['cursor'] = 'default';
        }
      } catch (e) {
      }
      this.dataIS['AjaxValidationIsCurrentlyRunning'] = false;
    }
  } catch (e$0) {
    Ext.log('Exception in InitIS:' + e$0.message);
  }
  this.dataIS['ajaxLoad'] = false;
}, addPatternMatchIS:function(pattern, id, errorText, namespace) {
  inubitwebapp.services.Script.addPatternMatchIS(pattern, id, errorText, namespace, this);
}, ajaxSubmitIS:function(trigger, url, groupOrGroupId, jump, ns) {
  inubitwebapp.services.Script.ajaxSubmitIS(trigger, url, groupOrGroupId, jump, this, ns);
}, showHelpToolTip:function(ns, node) {
  inubitwebapp.services.Script.showHelpToolTip(ns, node, this);
}, submit:function(event, ns, url, progressMsg, successMsg, errorMsg) {
  if (inubitwebapp.services.Script.doSubmitIS(ns, this)) {
    this.dataIS[ns + 'done'] = false;
    inubitwebapp.services.Script.ajaxCallForSubmit(ns, url, this, progressMsg, successMsg, errorMsg);
  }
  return false;
}, doSubmitIS:function(event, namespace) {
  return inubitwebapp.services.Script.doSubmitIS(namespace ? namespace : '', this);
}, changeFormActionToUploadIS:function(newAction, namespace) {
  inubitwebapp.services.Script.changeFormActionToUploadIS(newAction, namespace, this);
}, backIS:function(namespace) {
  inubitwebapp.services.Script.backIS(namespace, this);
}, setSubmitPropertyIS:function(target, validate, namespace) {
  inubitwebapp.services.Script.setSubmitPropertyIS(target, validate, namespace, this);
}, setStyleIS:function(componentOrId, styleName, value) {
  var ns = arguments.length > 3 ? arguments[3] : '';
  var c = inubitwebapp.services.Script.componentIS(componentOrId, ns);
  if (c != null) {
    c.style[styleName] = value;
  }
}, handleScriptError:function(e, scriptText) {
  var $jscomp$this = this;
  scriptText = scriptText === void 0 ? '' : scriptText;
  if (!this.scriptErrorOccurred) {
    this.scriptErrorOccurred = true;
    Ext.defer(function() {
      if ($jscomp$this) {
        $jscomp$this.removeAll();
        var p = $jscomp$this.add({xtype:'panel', itemId:'forceJSerrorPanel', flex:1, tbar:[{xtype:'button', iconCls:inubitwebapp.Support.getBpcIconCls('fa-exclamation-triangle'), text:$jscomp$this.TR('ERROR_INJECT_SCRIPT'), tooltip:$jscomp$this.TR('ERROR_COPY_PAYLOAD'), handler:function(b) {
          if (inubitwebapp.Support.copyToClipBoard(scriptText, $jscomp$this)) {
            $jscomp$this.showNotification($jscomp$this.TR('TEXT_COPIED'));
          }
        }}, {xtype:'textfield', fieldLabel:$jscomp$this.TR('ERROR_TYPE'), value:e.name || '-1', readOnly:true, flex:1, margin:'0 0 0 5'}, {xtype:'textfield', fieldLabel:$jscomp$this.TR('ERROR_MESSAGE'), value:e.message || '-1', readOnly:true, flex:1, margin:'0 0 0 5'}, {xtype:'textfield', fieldLabel:$jscomp$this.TR('ERROR_LINE_NUMBER'), value:e.lineNumber || '-1', readOnly:true, flex:1, margin:'0 0 0 5'}, {xtype:'textfield', fieldLabel:$jscomp$this.TR('ERROR_COLUMN_NUMBER'), value:e.columnNumber || 
        '-1', readOnly:true, flex:1, margin:'0 0 0 5'}], layout:'fit', items:[{xtype:'textarea', value:scriptText, readOnly:true, grow:true}]});
        p.setWidth('100%');
        p.setHeight('100%');
      }
    }, 500);
  }
}});
Ext.define('inubitwebapp.bpc.widget.DashboardWebAppWidget', {extend:'Ext.panel.Panel', alias:'widget.webAppWidget', mixins:['BpcCommon.mixin.Widget'], statics:{WIDGET_NAME:'Web Application Widget', WIDGET_DESCRIPTION:BpcCommon.Api.getTranslation('INUBITWEBAPP_WIDGET_DESCRIPTION'), WIDGET_ICON_CLS:'x-fab fa-wpforms'}, widgetConfigSettingMap:{moduleId:{settingType:'moduleInstance'}}, config:{widgetConfiguration:{}}, layout:'card', activeItem:0, title:false, moduleId:undefined, widgetId:undefined, wrongConfigPanel:{xtype:'container', 
padding:'10 10 10 10', items:[{xtype:'box', html:'Die Konfiguration ist unvollständig. Es muss mindestens der zugehörige Monitor augewählt sein.'}, {xtype:'button', text:'Konfiguration anzeigen', iconCls:'x-fal fa-cogs', handler:function() {
  var widget = this.up('tsmViewWidget');
  widget.getLayout().setActiveItem(widget.settingPanel);
}}]}, initComponent:function() {
  try {
    this.initWidgetSettings();
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR initComponent booting WidgetSettings', dump:e, stack:true, level:'error'});
  }
  this.callParent(arguments);
  this.initWidget();
  this.settingPanel = this.add({xtype:'bpcSettingPanel', settings:this.settingStore, buttons:[{text:'OK', handler:this.configureWidget.bind(this)}, {text:'Standardwerte', handler:this.prepareWidgetConfiguration.bind(this, true)}]});
}, initWidget:function() {
  var $jscomp$this = this;
  var widgetDisplayCmp = {xtype:'container', html:'Die ModuleId wurde dem Widget nicht zugewiesen oder existiert nicht.'};
  if (this.moduleId) {
    var dbComp = this.up('dbMain');
    var matchingWidgets = null;
    if (dbComp && dbComp.isComponent) {
      matchingWidgets = dbComp.query('#bpcWebAppMain').filter(function(a) {
        return a.moduleId === $jscomp$this.moduleId && a.isVisible() === true;
      });
    }
    if (matchingWidgets != null && matchingWidgets.length > 0) {
      widgetDisplayCmp.html = inubitwebapp.Support.TR('DASHBOARD_MULTI_INSTANCE');
    } else {
      widgetDisplayCmp = Ext.create(Ext.apply({}, {xtype:'bpcWebAppMain'}, {moduleId:this.moduleId, baseUrl:inubitwebapp.Support.getBaseUrl()}));
    }
  }
  this.wrapper = this.add(widgetDisplayCmp);
}, refreshWidget:function() {
}, configureWidget:function() {
  var card = this.settingPanel;
  if (card && card.isComponent && card.isVisible(true)) {
    card = this.wrapper;
  }
  this.getLayout().setActiveItem(card);
}});
Ext.define('inubitwebapp.bpc.window.Tooltip', {extend:'Ext.tip.ToolTip', alias:'window.inubitwebapptooltip', itemId:'inubitwebapptooltip', closable:true, closeAction:'hide', anchor:'left', anchorToTarget:true, mouseOffset:[50, 100], minWidth:150, minHeight:30});
Ext.define('inubitwebapp.BpcInterface', {extend:'BpcCommon.BpcInterface', requires:['inubitwebapp.bpc.widget.DashboardWebAppWidget'], config:{moduleConfigurationComponents:[], baseModuleView:null, mainView:null, widgets:['inubitwebapp.bpc.widget.DashboardWebAppWidget']}});
Ext.define('inubitwebapp.services.AjaxScript', {extend:'Ext.Base', singleton:true, reinitAjaxDOM:function(ns, currentPage) {
  var parser = new DOMParser();
  currentPage.ajaxValidation.DOM = parser.parseFromString('\x3c?xml version\x3d"1.0" encoding\x3d"UTF-8"?\x3e\x3cresult/\x3e', 'text/xml');
  currentPage.ajaxValidation.portletNS = ns;
  currentPage.ajaxValidation.form = document.getElementsByTagName('form').namedItem(ns + 'formIS');
}, doSubmitWithAjaxValidation:function(moduleId) {
  var currentPage = inubitwebapp.services.Script.getCurrentPage(moduleId);
  if (currentPage) {
    if (currentPage.dataIS.key == '13') {
      currentPage.dataIS.key = null;
      return false;
    }
    inubitwebapp.services.AjaxScript.getValidationIS(this, false, 'Submission');
  }
  return false;
}, getValidationIS:function(validationButton, errorNodesMustBeVisible, caller) {
  return false;
}, setSubmitAjax:function(node, moduleId) {
  if (inubitwebapp.services.Script.hasAttribute(node, 'preSubmitCode')) {
    node.onclick = inubitwebapp.services.AjaxScript.doSubmitWithAjaxValidation(moduleId);
  }
}, doAjaxSubmitWithAjaxValidation:function() {
  inubitwebapp.services.AjaxScript.getValidationIS(this, false, 'ajaxSubmission');
  return false;
}, addToAjaxErrorNodes:function(node, errorMsg, currentPage) {
  if (!node) {
    return;
  }
  if (!currentPage.ajaxValidation.DOM) {
    inubitwebapp.services.AjaxScript.reinitAjaxDOM(inubitwebapp.services.Script.getPortletNsIS(node));
  }
  var htmls = currentPage.ajaxValidation.DOM.getElementsByTagName('html');
  for (var c = 0; c < htmls.length; c++) {
    if (htmls[c].firstChild.nodeValue == errorMsg) {
      var nodes = htmls[c].getElementsByTagName('errornode');
      for (var i$1 = 0; i$1 < nodes.length; i$1++) {
        if (inubitwebapp.services.Script.getIdWithoutNsIS(node) == nodes[i$1].firstChild.nodeValue) {
          return;
        }
      }
      var errorNode2Add = ajaxValidation.DOM.createElement('errornode');
      errorNode2Add.appendChild(ajaxValidation.DOM.createTextNode(inubitwebapp.services.Script.getIdWithoutNsIS(node)));
      htmls[c].getElementsByTagName('errornodes')[0].appendChild(errorNode2Add);
      return;
    }
  }
  var result = currentPage.ajaxValidation.DOM.getElementsByTagName('result')[0];
  var html = currentPage.ajaxValidation.DOM.createElement('html');
  var errorNodesID = currentPage.ajaxValidation.DOM.createAttribute('id');
  errorNodesID.nodeValue = 'patternMatched_' + htmls.length;
  var errorNodes = currentPage.ajaxValidation.DOM.createElement('errornodes');
  errorNodes.setAttributeNode(errorNodesID);
  var errorNode = currentPage.ajaxValidation.DOM.createElement('errornode');
  result.appendChild(html);
  html.appendChild(currentPage.ajaxValidation.DOM.createTextNode(errorMsg));
  html.appendChild(errorNodes);
  errorNodes.appendChild(errorNode);
  errorNode.appendChild(currentPage.ajaxValidation.DOM.createTextNode(inubitwebapp.services.Script.getIdWithNsIS(node)));
}, showALLErrorNodes:function(errorDOM, currentPage) {
  var nameWithNamespace = arguments.length > 2 ? arguments[2] : false;
  inubitwebapp.services.AjaxScript.removeALLErrorNodes(currentPage);
  var errorNodes = Array.from(errorDOM.getElementsByTagName('errornodes'));
  for (var c = 0; c < errorNodes.length; c++) {
    inubitwebapp.services.AjaxScript.showErrorNodes(errorNodes[c], false, currentPage, nameWithNamespace);
  }
  currentPage.ajaxValidation.allErrorNodesAreBlocked = true;
}, showErrorNodes:function(errorNodes, setFocus, currentPage) {
  var nameWithNamespace = arguments.length > 3 ? arguments[3] : false;
  if (errorNodes) {
    for (var c = 0; c < errorNodes.childNodes.length; c++) {
      if (errorNodes.childNodes[c].firstChild) {
        var errorInput;
        if (nameWithNamespace) {
          errorInput = document.getElementById(errorNodes.childNodes[c].firstChild.nodeValue);
        } else {
          errorInput = document.getElementById(currentPage.ajaxValidation.portletNS + errorNodes.childNodes[c].firstChild.nodeValue);
        }
        if (errorInput) {
          var isErrorNode = errorInput.getAttribute('isErrorNode');
          if (isErrorNode == undefined || typeof isErrorNode == 'string' && isErrorNode != 'true') {
            errorInput.setAttribute('isErrorNode', 'true');
            errorInput.setAttribute('originalBackgroundColorIS', inubitwebapp.services.Script.createStyle(errorInput, 'background-color'));
            errorInput.setAttribute('originalBackgroundImageIS', inubitwebapp.services.Script.createStyle(errorInput, 'background-image'));
          }
          inubitwebapp.services.Script.setStyleIS(errorInput, 'background', 'none');
          inubitwebapp.services.Script.setStyleIS(errorInput, 'backgroundColor', currentPage.dataIS[currentPage.ajaxValidation.portletNS + 'warningColor']);
        }
      }
    }
  }
}, removeALLErrorNodes:function(currentPage) {
  if (currentPage) {
    currentPage.ajaxValidation.currentSelectedErrorMessage = undefined;
    var controls = Array.from(currentPage.ajaxValidation.form);
    for (i = 0; i < controls.length; i++) {
      var isErrorNode = controls[i].getAttribute('isErrorNode');
      if (typeof isErrorNode == 'string' && isErrorNode == 'true') {
        var type = controls[i].getAttribute('type');
        if (type == 'submit' || type == 'button') {
          return;
        }
        controls[i].setAttribute('isErrorNode', 'false');
        var restoreStye = '';
        restoreStye += controls[i].getAttribute('originalBackgroundColorIS') + ' ';
        restoreStye += controls[i].getAttribute('originalBackgroundImageIS') + ' ';
        inubitwebapp.services.Script.setStyleIS(controls[i], 'background', restoreStye);
      }
    }
    currentPage.ajaxValidation.allErrorNodesAreBlocked = false;
  }
}, getErrorHeading:function(heading, errorCount) {
  if (errorCount < 2) {
    var tmp = '';
    var inScript = false;
    for (var c = 0; c < heading.length; c++) {
      if (heading.charAt(c) == '{') {
        inScript = true;
      }
      if (heading.charAt(c) == '}') {
        inScript = false;
      }
      if (!inScript) {
        tmp += heading.charAt(c);
      }
    }
    heading = tmp;
  }
  heading = inubitwebapp.services.Script.stringReplaceAll(heading, '{errorCount}', errorCount < 2 ? '' : String(errorCount));
  heading = inubitwebapp.services.Script.stringReplaceAll(heading, '{', '');
  heading = inubitwebapp.services.Script.stringReplaceAll(heading, '}', '');
  return heading;
}, getErrorMessageCount:function(currentPage) {
  var count = 0;
  var htmls = currentPage.ajaxValidation.DOM.getElementsByTagName('html');
  for (var c = 0; c < htmls.length; c++) {
    if (htmls[c].firstChild.nodeValue.length > 0) {
      count++;
    }
  }
  return count;
}});
Ext.define('inubitwebapp.services.Script', {extend:'Ext.Base', singleton:'true', activeSubmits:{}, loadAJAXScriptsIS:function(response, currentPage, namespace) {
  if (response.responseText.length > 0) {
    try {
      inubitwebapp.services.Script.removeResources(currentPage);
      var srcs = inubitwebapp.services.Script.extractScriptSrcsIS(response.responseText);
      for (var j = 0; j < srcs.length; j++) {
        if (srcs[j].length > 0) {
          inubitwebapp.services.Script.addScriptIS(srcs[j], new function() {
          }());
        }
      }
    } catch (e) {
      alert(e);
    }
  }
}, initIS:function(params, dataIS, moduleId) {
  var currentPage = inubitwebapp.services.Script.getCurrentPage(moduleId);
  if (currentPage) {
    currentPage.setDataIS(dataIS);
    dataIS = null;
    try {
      if (currentPage.dataIS['ajaxLoad']) {
        try {
          if (currentPage.ajaxValidation.form !== null) {
            currentPage.ajaxValidation.form.style['cursor'] = 'default';
          }
        } catch (e) {
        }
        currentPage.dataIS['AjaxValidationIsCurrentlyRunning'] = false;
      }
    } catch (e$2) {
      Ext.log('Exception in InitIS:' + e$2.message);
    }
    currentPage.dataIS['ajaxLoad'] = false;
  }
}, ajaxCallForSubmit:function(ns, url, currentPage, progressMsg, successMsg, errorMsg) {
  var me = this;
  try {
    if (currentPage.dataIS[ns + 'webFormName']) {
    }
    url = url.includes(currentPage.dataIS[ns + 'webFormName']) ? url : url.replace(url.split('\x26').filter(function(a) {
      return a.startsWith('WebAppIdentifier');
    })[0].split('\x3d')[1], currentPage.dataIS[ns + 'webFormName']);
  } catch (e) {
    console.log(e);
  }
  if (me.activeSubmits[currentPage.moduleId]) {
    console.warn('block submit, there is a pending submit!');
    return;
  } else {
    me.activeSubmits[currentPage.moduleId] = true;
  }
  currentPage.setLoading('SUBMITTING_DATA');
  inubitwebapp.Support.submitViaExtJs('POST', url, new FormData(document.getElementById(ns + 'formIS')), undefined, currentPage.moduleId).then(function(response) {
    if ([200, 204].indexOf(response.status) !== -1) {
      if (successMsg) {
        currentPage.showNotification(successMsg);
      }
      if (response.responseText) {
        currentPage.destroyOldComponents(currentPage.namespace);
        currentPage.setHtml(response.responseText);
        inubitwebapp.services.Script.loadAJAXScriptsIS(response, currentPage);
      } else {
        currentPage.setHtml(inubitwebapp.Support.TR('SUBMISSION_SUCCESS'));
      }
    }
    me.activeSubmits[currentPage.moduleId] = false;
    currentPage.setLoading(false);
  }, function(error) {
    if (errorMsg) {
      currentPage.showNotification(errorMsg, 'e');
    }
    inubitwebapp.services.Script.handleError(error, currentPage);
    me.activeSubmits[currentPage.moduleId] = false;
    currentPage.setLoading(false);
  });
  if (progressMsg) {
    currentPage.showNotification(progressMsg);
  }
  return false;
}, checkForExtForSubmit:function(event, ns, url, moduleId, progressMsg, successMsg, errorMsg) {
  var currentPage = inubitwebapp.services.Script.getCurrentPage(moduleId);
  if (currentPage) {
    if (inubitwebapp.services.Script.doSubmitIS(ns, currentPage)) {
      currentPage.dataIS[ns + 'done'] = false;
      inubitwebapp.services.Script.ajaxCallForSubmit(ns, url, currentPage, progressMsg, successMsg, errorMsg);
    }
    return false;
  }
}, checkForExt:function(event, ns, url, formData, portalInfo, moduleId) {
  var currentPage = inubitwebapp.services.Script.getCurrentPage(moduleId);
  if (currentPage) {
    return inubitwebapp.services.Script.doSubmitIS(ns, currentPage);
  }
}, ajaxSubmitIS:function(trigger, url, groupOrGroupId, jump, moduleId, ns) {
  var currentPage = inubitwebapp.services.Script.getCurrentPage(moduleId);
  currentPage.showNotification(inubitwebapp.Support.TR('SUBMISSION_INPROGRESS'));
  var form = document.getElementById(ns + 'formIS');
  var urlWithData = url + '\x26ajaxSubmitIS\x3dtrue\x26' + (groupOrGroupId != null ? 'ISAjaxGroup\x3d' + groupOrGroupId + '\x26' : '') + (jump != null ? 'ISJump\x3d' + jump : '');
  inubitwebapp.Support.submitViaExtJs('POST', urlWithData, new FormData(form), undefined, moduleId).then(function(response) {
    if ([200, 204].indexOf(response.status) !== -1) {
      var currentPage = inubitwebapp.services.Script.getCurrentPage();
      if (currentPage) {
        currentPage.showNotification(inubitwebapp.Support.TR('FORM_SUCCESSFUL'));
        currentPage.destroyOldComponents(currentPage.namespace);
        if (response.responseText) {
          if (groupOrGroupId) {
            document.getElementById(ns + groupOrGroupId).parentNode.innerHTML = response.responseText;
          } else {
            document.getElementById(ns + 'innerIS').parentNode.innerHTML = response.responseText;
          }
          currentPage.dataIS[ns + 'webFormName'] = response.getResponseHeader('webappidentifier');
          inubitwebapp.services.Script.loadAJAXScriptsIS(response, currentPage);
        } else {
          currentPage.setHtml(inubitwebapp.Support.TR('SUBMISSION_SUCCESS'));
        }
      }
    }
  }, function(error) {
    inubitwebapp.services.Script.handleError(error, currentPage);
  });
  return false;
}, doSubmitIS:function(namespace, currentPage) {
  var ns = namespace ? namespace : '';
  var result = inubitwebapp.services.Script.patternMatchIS(ns, currentPage);
  if (result) {
    try {
      if (currentPage.dataIS[ns + 'validate']) {
        if (!inubitwebapp.services.Script.doServerSideValidation(ns, currentPage)) {
          return false;
        }
      }
    } catch (e) {
      console.log('Exception thrown in server side validation' + e);
    }
  }
  if (currentPage.dataIS.key == '13') {
    currentPage.dataIS.key = null;
    return false;
  }
  if (result) {
    currentPage.dataIS[ns + 'done'] = true;
  }
  return result;
}, getFormDataIS:function(namespace, form) {
  if (form) {
    return Ext.dom.Element.serializeForm(form);
  } else {
    return Ext.dom.Element.serializeForm(document.getElementsByName(namespace)[0]);
  }
}, setFormDataIS:function(html) {
  var ns = arguments.length > 1 ? arguments[1] : '';
  console.log('The function setFormDataIS is not implemented. Please contact Virtimo for suport');
}, setFormUrlIS:function(url, callback) {
  new Ext.Ajax.request({url:url, method:'get', success:callback});
}, removeComponentIS:function(componentOrId, descendantLevel) {
  var ns = arguments.length > 2 ? arguments[2] : '';
  var c = inubitwebapp.services.Script.componentIS(componentOrId, ns);
  var parent = c;
  if (descendantLevel > 0) {
    for (var i$3 = 0; i$3 <= descendantLevel && parent.parentNode != null; i$3++) {
      parent = parent.parentNode;
    }
  }
  parent.parentNode.removeChild(parent);
  return c;
}, componentIS:function(componentOrId) {
  if (!inubitwebapp.services.Script.isComponentIS(componentOrId)) {
    var ns = arguments.length > 1 ? arguments[1] : '';
    return document.getElementById(ns + componentOrId);
  } else {
    return componentOrId;
  }
}, getComponentFromPage:function(componentOrId, currentPage) {
  return currentPage.el.down('[name\x3d' + componentOrId).dom;
}, isVisibleIS:function(componentOrId) {
  var ns = arguments.length > 1 ? arguments[1] : '';
  var c = inubitwebapp.services.Script.componentIS(componentOrId, ns);
  while (c != null) {
    if (c.style != null && c.style.display == 'none') {
      return false;
    }
    c = c.parentNode;
  }
  return true;
}, isComponentIS:function(node) {
  if (node == null || node == undefined || node.nodeType == undefined) {
    return false;
  } else {
    return node.nodeType == 1;
  }
}, patternMatchIS:function(namespace, currentPage) {
  var ns = namespace ? namespace : '';
  var local = currentPage.dataIS[ns + 'vForms'];
  var result = true;
  var language = 'de';
  inubitwebapp.services.AjaxScript.reinitAjaxDOM(ns, currentPage);
  if (currentPage.dataIS[ns + 'validate']) {
    for (var loop = 0; loop < local.length; loop++) {
      var element = inubitwebapp.services.Script.componentIS(local[loop].id, ns);
      if (local[loop].pattern != null && element) {
        var regExp = new RegExp(local[loop].pattern);
        if (inubitwebapp.services.Script.isVisibleIS(element) && !element.disabled && !regExp.test(inubitwebapp.services.Script.getDataIS(element.id))) {
          result = false;
          inubitwebapp.services.AjaxScript.addToAjaxErrorNodes(element, local[loop].errMsg, currentPage);
          language = currentPage.dataIS[inubitwebapp.services.Script.getPortletNsIS(element) + 'lang'];
        }
      }
    }
    try {
      inubitwebapp.services.AjaxScript.showALLErrorNodes(currentPage.ajaxValidation.DOM, currentPage, true);
      if (arguments.length < 3) {
        var errorMessageCount = inubitwebapp.services.AjaxScript.getErrorMessageCount(currentPage);
        if (errorMessageCount == 0) {
          return result;
        }
        var headline;
        if (language == 'de') {
          headline = inubitwebapp.services.AjaxScript.getErrorHeading('{errorCount} Fehler bei der Formularpr\x26uuml;fung', errorMessageCount);
        } else {
          headline = inubitwebapp.services.AjaxScript.getErrorHeading('{errorCount} error{s} at form validation', errorMessageCount);
        }
        var errors = currentPage.ajaxValidation.DOM.getElementsByTagName('html');
        if (window.tooltip === undefined) {
          window.tooltip = Ext.create('window.inubitwebapptooltip');
        } else {
          tooltip.hide();
        }
        var content = inubitwebapp.services.Script.createErrorContent(errors);
        if (currentPage.dataIS.submitter) {
          currentPage.ajaxValidation.submitter = currentPage.dataIS.submitter;
        }
        tooltip.setTitle(headline);
        tooltip.setData(content);
        tooltip.target = document.getElementsByName(currentPage.moduleId)[0];
        tooltip.anchor = 'top';
        tooltip.show();
      }
    } catch (e) {
    }
  }
  return result;
}, doServerSideValidation:function(namespace, currentPage) {
  if (window.tooltip === undefined) {
    window.tooltip = Ext.create('window.inubitwebapptooltip');
  } else {
    tooltip.hide();
  }
  var isValidationSuccess = true;
  var form = inubitwebapp.services.Script.getFormDataIS(namespace);
  var moduleId = currentPage.moduleId;
  var lang = BpcCommon.Api.getSetting('_core', 'language');
  var helpUrl = inubitwebapp.Support.getBaseUrl() + 'help?instanceId\x3d' + moduleId + '\x26lang\x3d' + lang + '\x26ajaxType\x3dvalidation\x26ajaxMode\x3dajaxSubmission\x26form\x3d' + currentPage.dataIS[namespace + 'webFormName'];
  var response = inubitwebapp.Support.submitViaExtJs('POST', helpUrl, form, undefined, moduleId);
  if (response.status === 200 && response.responseText !== 'ERROR - ValidatePredicates are NULL.') {
    inubitwebapp.services.AjaxScript.removeALLErrorNodes(currentPage);
    var parser = new DOMParser();
    var xmlDoc = parser.parseFromString(response.responseText, 'text/xml');
    var errors = xmlDoc.getElementsByTagName('html');
    if (errors.length === 0) {
      return isValidationSuccess;
    }
    isValidationSuccess = false;
    inubitwebapp.services.AjaxScript.showALLErrorNodes(xmlDoc, currentPage, false);
    var content = inubitwebapp.services.Script.createErrorContent(errors);
    tooltip.setData(content);
    tooltip.setTitle(xmlDoc.getElementsByTagName('heading')[0].childNodes[0].nodeValue);
    tooltip.target = document.getElementsByName(namespace)[0];
    tooltip.anchor = 'top';
    tooltip.show();
  }
  return isValidationSuccess;
}, setSubmitPropertyIS:function(target, validate, namespace, moduleId) {
  var ns = namespace ? namespace : '';
  if (inubitwebapp.services.Script.componentIS('hiddenSubmitIS', ns)) {
    inubitwebapp.services.Script.componentIS('hiddenSubmitIS', ns).value = target;
  }
  var currentPage = inubitwebapp.services.Script.getCurrentPage(moduleId);
  if (currentPage) {
    currentPage.dataIS[ns + 'validate'] = !(validate == 'false');
  }
}, hasAttribute:function(node, attributeName) {
  if (node == null) {
    return false;
  }
  try {
    var test = node.getAttribute(attributeName);
    if (test != null) {
      return true;
    }
  } catch (e) {
    return false;
  }
  return false;
}, setDataIS:function(componentOrId, data) {
  var ns = arguments.length > 2 ? arguments[2] : '';
  var c = inubitwebapp.services.Script.componentIS(componentOrId, ns);
  if (c != null) {
    if (c.type == 'checkbox' || c.type == 'radio') {
      c.checked = data;
    } else {
      c.value = data;
    }
  }
}, getDataIS:function(componentOrId, currentPage) {
  var ns = arguments.length > 2 ? arguments[2] : '';
  var c;
  if (currentPage) {
    c = inubitwebapp.services.Script.getComponentFromPage(componentOrId, currentPage);
  } else {
    c = inubitwebapp.services.Script.componentIS(componentOrId, ns);
  }
  if (c != null) {
    if (c.type == 'checkbox' || c.type == 'radio') {
      return c.checked;
    } else {
      return c.value;
    }
  }
  return null;
}, incrementAttributeNumber:function(el, attribute) {
  if (el && el[attribute]) {
    var regex = /\d+/;
    var match = regex.exec(el[attribute]);
    if (match) {
      el[attribute] = el[attribute].replace(match[0], parseInt(match[0]) + 1);
    } else {
      el[attribute] = el[attribute] + '_1';
    }
  }
}, incrementIdAndName:function(el) {
  inubitwebapp.services.Script.incrementAttributeNumber(el, 'id');
  inubitwebapp.services.Script.incrementAttributeNumber(el, 'name');
}, copyComponent:function(selector) {
  var nodes = document.querySelectorAll(selector);
  var template = nodes[nodes.length - 1];
  var copy = template.cloneNode(true);
  inubitwebapp.services.Script.incrementIdAndName(copy);
  copy.querySelectorAll('[id],[name]').forEach(inubitwebapp.services.Script.incrementIdAndName);
  template.parentNode.appendChild(copy);
}, getFormIS:function(node) {
  if (node == undefined || node == null || node.nodeType != 1) {
    return null;
  } else if (node.nodeName.toUpperCase() == 'FORM') {
    return node;
  } else {
    return inubitwebapp.services.Script.getFormIS(node.parentNode);
  }
}, getPortletNsIS:function(node) {
  return inubitwebapp.services.Script.getFormIS(node) ? inubitwebapp.services.Script.getFormIS(node).getAttribute('name').replaceAll('-', '___') : null;
}, getFormIdentifierIS:function(node, moduleId) {
  var currentPage = inubitwebapp.services.Script.getCurrentPage(moduleId);
  if (currentPage) {
    return currentPage.dataIS[inubitwebapp.services.Script.getPortletNsIS(node) + 'form'];
  }
}, stringReplaceAll:function(sourceStr, findStr, repStr) {
  return sourceStr.replace(new RegExp(findStr, 'g'), repStr);
}, addPatternMatchIS:function(pattern, id, errorText, namespace, moduleId) {
  var currentPage = inubitwebapp.services.Script.getCurrentPage(moduleId);
  var ns = namespace ? namespace : '';
  var o = new Object();
  o.pattern = pattern;
  o.id = id;
  o.errMsg = errorText;
  if (currentPage.dataIS) {
    currentPage.updateDataISArray(ns + 'vForms', o);
  }
}, showHelpToolTip:function(ns, node, moduleId) {
  var currentPage = inubitwebapp.services.Script.getCurrentPage(moduleId);
  if (currentPage) {
    if (currentPage.dataIS[ns + 'ajaxHelp'] === false || currentPage.dataIS[ns + 'ajaxHelp'] === 'false') {
      return;
    }
    if (window.tooltip === undefined) {
      window.tooltip = Ext.create('window.inubitwebapptooltip');
    } else {
      tooltip.hide();
    }
    var lang = BPC.getApplication().getController('BPC.controller.ConfigurationController').localConfiguration._core.language;
    var helpUrl = inubitwebapp.Support.getBaseUrl() + 'help?instanceId\x3d' + currentPage.moduleId + '\x26lang\x3d' + lang + '\x26ajaxType\x3dhelp\x26ajaxMode\x3dExperte\x26ajaxNode\x3d' + node.id.replace(inubitwebapp.services.Script.getPortletNsIS(node), '') + '\x26form\x3d' + currentPage.dataIS[ns + 'webFormName'];
    var data = inubitwebapp.services.Script.stringReplaceAll(Ext.dom.Element.serializeForm(inubitwebapp.services.Script.getFormIS(node)), inubitwebapp.services.Script.getPortletNsIS(node), '');
    inubitwebapp.Support.submitViaExtJs('POST', helpUrl, data, {'Content-Type':'text/xml'}, currentPage.moduleId).then(function(response) {
      if (response.status >= 200 && response.status < 300) {
        var parser = new DOMParser();
        var xmlDoc = parser.parseFromString(response.responseText, 'text/xml');
        tooltip.setData(xmlDoc.getElementsByTagName('html')[0].childNodes[0].nodeValue);
        tooltip.setTitle(xmlDoc.getElementsByTagName('heading')[0].childNodes[0].nodeValue);
        tooltip.target = document.getElementById(node.id);
        tooltip.anchor = 'left', tooltip.show();
      }
    });
  }
}, getIdWithoutNsIS:function(element) {
  if (!inubitwebapp.services.Script.hasAttribute(element, 'id')) {
    return '';
  }
  var id = element.getAttribute('id');
  if (id.indexOf(inubitwebapp.services.Script.getPortletNsIS(element)) != -1) {
    return id.substring(inubitwebapp.services.Script.getPortletNsIS(element).length);
  } else {
    return id;
  }
}, getIdWithNsIS:function(element) {
  if (!inubitwebapp.services.Script.hasAttribute(element, 'id')) {
    return '';
  }
  var id = element.getAttribute('id');
  return id;
}, getContextPathIS:function(node, moduleId) {
  var currentPage = inubitwebapp.services.Script.getCurrentPage(moduleId);
  if (currentPage) {
    return currentPage.dataIS[inubitwebapp.services.Support.getPortletNsIS(node) + 'contextPath'];
  }
}, setStyleIS:function(componentOrId, styleName, value) {
  var ns = arguments.length > 3 ? arguments[3] : '';
  var c = inubitwebapp.services.Script.componentIS(componentOrId, ns);
  if (c != null) {
    c.style[styleName] = value;
  }
}, createStyle:function(element, style) {
  element = element;
  style = style == 'float' ? 'cssFloat' : inubitwebapp.services.Script.camelize(style);
  var value = element.style[style];
  if (!value || value == 'auto') {
    var css = document.defaultView.getComputedStyle(element, null);
    value = css ? css[style] : null;
  }
  if (style == 'opacity') {
    return value ? parseFloat(value) : 1;
  }
  return value == 'auto' ? null : value;
}, camelize:function(style) {
  return style.replace(/-+(.)?/g, function(match, chr) {
    return chr ? chr.toUpperCase() : '';
  });
}, createErrorContent:function(errors) {
  var content = '';
  for (var c = 0; c < errors.length; c++) {
    content += errors[c].childNodes[0].nodeValue + '\x3c/br\x3e';
  }
  return content;
}, disableSubmitButtons:function(namespace, setFlag) {
  if (setFlag) {
    els = document[namespace].querySelectorAll('[type\x3dsubmit]:enabled,[type\x3dbutton]:enabled');
  }
  for (var i$4 = 0; i$4 < els.length; i$4++) {
    els[i$4].disabled = setFlag;
  }
  if (!setFlag) {
    els = [];
  }
}, getStyleIS:function(componentOrId, styleName) {
  var ns = arguments.length > 2 ? arguments[2] : '';
  var c = inubitwebapp.services.Script.componentIS(componentOrId, ns);
  if (c != null) {
    return c.style[styleName];
  } else {
    return null;
  }
}, extractScriptSrcsIS:function(string) {
  var matchAll = new RegExp('(?:\x3cscript.*?src\x3d["\'](.*?)["\'].*?\x3e).*?(?:\x3c/script\x3e)', 'img');
  var matchOne = new RegExp('(?:\x3cscript.*?src\x3d["\'](.*?)["\'].*?\x3e).*?(?:\x3c/script\x3e)', 'im');
  return (string.match(matchAll) || []).map(function(scriptTag) {
    return (scriptTag.match(matchOne) || ['', ''])[1];
  });
}, addScriptIS:function(url, cache, callback) {
  Ext.Loader.loadScript({url:url, onLoad:function(response) {
    this.window.onerror = function(event, source, lineno, colNo, error) {
      var forceValidScript = BpcCommon.Api.getSetting(inubitwebapp.services.Script.getCurrentPage().moduleId, 'forceValidScriptInjection');
      if (forceValidScript) {
        inubitwebapp.services.Script.getCurrentPage().handleScriptError(error, source);
      } else {
        console.error(error);
      }
    };
  }});
}, showMessageIS:function(title, message) {
  var text = title ? title : '';
  if (message) {
    text = text + '\n' + message;
  }
  inubitwebapp.Support.showNotification({text:text, popUp:true});
}, centerInWindow:function(componentOrId) {
  var c = inubitwebapp.services.Script.componentIS(componentOrId);
  var s = c.style;
  s.position = 'fixed';
  if (window.innerWidth) {
    s.left = (window.innerWidth - c.offsetWidth) / 2;
    s.top = (window.innerHeight - c.offsetHeight) / 2;
  } else {
    s.left = (document.body.offsetWidth - c.offsetWidth) / 2;
    s.top = (document.body.offsetHeight - c.offsetHeight) / 2;
  }
}, removeResources:function(currentPage, namespace) {
  var ns = namespace ? namespace : '';
  if (currentPage) {
    if (currentPage.dataIS[ns + 'resources']) {
      for (var i$5 = 0; i$5 < currentPage.dataIS[ns + 'resources'].length; i$5++) {
        var child = currentPage.dataIS[ns + 'resources'][i$5];
        child.parentNode.removeChild(child);
      }
    }
    currentPage.dataIS[ns + 'resources'] = new Array();
  }
}, cleanForReinit:function(webAppPage) {
  this.removeResources(webAppPage, webAppPage.namespace);
  webAppPage.destroyOldComponents(webAppPage.namespace);
  webAppPage.removeAll();
}, handleError:function(error, currentPage) {
  if (error.status === 503) {
    error.statusText = inubitwebapp.Support.TR('SERVICE_UNAVAILABLE_MSG');
    currentPage.showNotification(inubitwebapp.Support.TR('SERVICE_UNAVAILABLE_MSG'), 'e');
  } else if (error.status === 401) {
    error.statusText = inubitwebapp.Support.TR('UNAUTHORIZED');
    currentPage.showNotification(inubitwebapp.Support.TR('UNAUTHORIZED'), 'e');
  } else if (error.status === 417) {
    error.statusText = inubitwebapp.Support.TR('EXPECTATION_FAILED');
    currentPage.showNotification(inubitwebapp.Support.TR('EXPECTATION_FAILED'), 'e');
  } else if (error.status === 400) {
    if (error.getResponseHeader('Process_Id')) {
      error.statusText = BpcCommon.Api.getTranslation({key:'INUBITWEBAPP_BAD_REQUEST_MSG', data:{processId:error.getResponseHeader('Process_Id')}});
    } else {
      error.statusText = inubitwebapp.Support.TR('BACKEND_ERROR');
    }
  } else {
    currentPage.showNotification(inubitwebapp.Support.TR('FORM_FAILED'), 'e');
  }
  if (currentPage) {
    currentPage.destroyOldComponents(currentPage.namespace);
    currentPage.setHtml('');
    currentPage.errorInPage = true;
    currentPage.add({xtype:'panel', margin:'10 10 10 10', html:'\x3cdiv\x3e\x3ch1\x3e' + inubitwebapp.Support.TR('SERVER_ERROR') + '\x3c/h1\x3e' + '\x3ch3\x3e' + error.statusText + '\x3c/h3\x3e\x3c/div\x3e'});
  }
}, addCssIS:function(file) {
  var link = document.createElement('link');
  link.setAttribute('rel', 'stylesheet');
  link.setAttribute('type', 'text/css');
  link.setAttribute('href', file);
  document.getElementsByTagName('head').item(0).appendChild(link);
}, backButtonOverrideIS:function() {
  inubitwebapp.services.Script.backButtonOverrideBodyIS();
}, backButtonOverrideBodyIS:function() {
  try {
    history.forward();
  } catch (e) {
  }
  inubitwebapp.services.Script.setTimeout('backButtonOverrideBodyIS()', 500);
}, backIS:function(namespace, moduleId) {
  var ns = namespace ? namespace : '';
  var currentPage = inubitwebapp.services.Script.getCurrentPage(moduleId);
  if (currentPage) {
    currentPage.dataIS[ns + 'panels'].pop();
  }
  self[ns + 'showPanelIS'](currentPage.dataIS[ns + 'panels'].pop());
}, getIS:function(panelName) {
  var ns = arguments.length > 1 ? arguments[1] : '';
  self[ns + 'showPanelIS'](panelName);
}, addParamToUrl:function(url1, delimiter, keyValuePair, portalInfo, nspace) {
  var url = url1 + delimiter;
  for (var property in keyValuePair) {
    if (keyValuePair.hasOwnProperty(property)) {
      url += property + '\x3d' + keyValuePair[property] + '\x26';
    }
  }
  return url.substring(0, url.length - 1);
}, changeFormActionToUploadIS:function(newAction, namespace, moduleId, page) {
  var ns = namespace ? namespace : '';
  var currentPage = inubitwebapp.services.Script.getCurrentPage(moduleId);
  if (currentPage) {
    currentPage.updateDataISProp(ns + 'validate', false);
  }
  inubitwebapp.services.Script.componentIS('formIS', ns).action = newAction;
  inubitwebapp.services.Script.componentIS('formIS', ns).enctype = 'multipart/form-data';
  inubitwebapp.services.Script.componentIS('formIS', ns).encoding = 'multipart/form-data';
}, getPositionIS:function(componentOrId) {
  var ns = arguments.length > 1 ? arguments[1] : '';
  var obj = inubitwebapp.services.Script.componentIS(componentOrId, ns);
  var pos = {left:0, top:0};
  if (typeof obj.offsetLeft != 'undefined') {
    while (obj) {
      pos.left += obj.offsetLeft;
      pos.top += obj.offsetTop;
      obj = obj.offsetParent;
    }
  } else {
    pos.left = obj.left;
    pos.top = obj.top;
  }
  return pos;
}, getHtmlIS:function(componentOrId) {
  var ns = arguments.length > 1 ? arguments[1] : '';
  var c = inubitwebapp.services.Script.componentIS(componentOrId, ns);
  return c.innerHTML;
}, setHtmlIS:function(componentOrId, html) {
  var ns = arguments.length > 2 ? arguments[2] : '';
  var c = inubitwebapp.services.Script.componentIS(componentOrId, ns);
  c.innerHTML = html;
}, getCurrentPage:function(moduleId) {
  var currentPage;
  var panels;
  if (moduleId) {
    if (moduleId.xtype && moduleId.xtype === 'bpcWebAppPage') {
      return moduleId;
    }
    panels = Ext.ComponentQuery.query('#bpcWebAppPage' + moduleId).filter(function(c) {
      return c.isVisible(true);
    });
    if (panels && panels.length > 0) {
      currentPage = panels[0];
    }
  } else {
    currentPage = Ext.ComponentQuery.query('#bpcWebAppMain').filter(function(c) {
      return c.isVisible(true);
    })[0].items.items[0];
  }
  return currentPage;
}, setDataISOnKeyDown:function(keyCode) {
  var currentPage = inubitwebapp.services.Script.getCurrentPage();
  if (currentPage) {
    currentPage.dataIS.key = keyCode;
  }
}, onKeyDown:function(event) {
  if (event.keyCode === 13) {
    if (event.srcElement.nodeName !== 'TEXTAREA') {
      event.preventDefault();
      return false;
    }
  }
}});
Ext.define('inubitwebapp.view.Main', {extend:'Ext.container.Container', itemId:'webAppMainContainer', layout:'fit', moduleId:undefined, moduleCfg:undefined, initComponent:function() {
  this.items = [{xtype:'bpcWebAppMain', moduleId:this.moduleId, moduleInstance:this}];
  this.callParent(arguments);
}, updateInstance:function(moduleCfg) {
  moduleCfg = moduleCfg === void 0 ? {} : moduleCfg;
  if (Ext.isObject(moduleCfg) && !Ext.Object.isEmpty(moduleCfg)) {
    this.moduleCfg = moduleCfg;
  }
}});
